docker

Posted wawahan

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了docker相关的知识,希望对你有一定的参考价值。

一、安装

rhel,centos

1、检查内核版本: 使用docker需要在64微系统上,内核版本3.8.13以上,之前的版本也可以使用,但是兼容性可能不是很好

#查看内核版本

uname -a 
uname -r 

2:检查device Mapper

  我们这里使用Device Mapper 作为Docker的存储启动。 

[root@centos-linux ~]# grep device-mapper /proc/devices
253 device-mapper

  如果没有就安装

[root@centos-linux ~]# yum install device-mapper

  *我有,但是我还是可以安装上。

安装完以后还需要加载dm_mod内核模块

[root@centos-linux ~]# modprobe dm_mod
[root@centos-linux ~]# lsmod | grep dm_mod
dm_mod                113292  8 dm_log,dm_mirror

[root@centos-linux ~]# ls /sys/class/misc/device-mapper/
dev power subsystem uevent

 

3、安装

centos 7 

[root@centos-linux yum.repos.d]# yum install subscription-manager
[root@centos-linux ~]# subscription-manager repos --enable=rhel-7-server-extras-rpms

想要访问red hat 的 docker 软件包和万当,必须是red hat的客户,并且拥有rhel服务器订阅权限(RHEL Server

sybscription entitlement)

 

 不用上面一步也可安装

root@centos-linux ~]# yum install -y docker

  

 

4、启动

[root@centos-linux ~]# service docker start .  or
[root@centos-linux ~]# systemctl start docker

 

开机启动

[root@centos-linux ~]# systemctl enable docker
[root@centos-linux ~]# systemctl list-dependencies docker 查看开机启动状

 

查看docker状态

[root@centos-linux ~]# docker info

  

Containers: 0
 Running: 0
 Paused: 0
 Stopped: 0
Images: 0
Server Version: 1.10.3
Storage Driver: devicemapper
 Pool Name: docker-253:0-67389343-pool
 Pool Blocksize: 65.54 kB
 Base Device Size: 10.74 GB
 Backing Filesystem: xfs
 Data file: /dev/loop0
 Metadata file: /dev/loop1
 Data Space Used: 11.8 MB
 Data Space Total: 107.4 GB
 Data Space Available: 17.86 GB
 Metadata Space Used: 581.6 kB
 Metadata Space Total: 2.147 GB
 Metadata Space Available: 2.147 GB
 Udev Sync Supported: true
 Deferred Removal Enabled: false
 Deferred Deletion Enabled: false
 Deferred Deleted Device Count: 0
 Data loop file: /var/lib/docker/devicemapper/devicemapper/data
 WARNING: Usage of loopback devices is strongly discouraged for production use. Either use `--storage-opt dm.thinpooldev` or use `--storage-opt dm.no_warn_on_loop_devices=true` to suppress this warning.
 Metadata loop file: /var/lib/docker/devicemapper/devicemapper/metadata
 Library Version: 1.02.135-RHEL7 (2016-09-28)
Execution Driver: native-0.2
Logging Driver: journald
Plugins:
 Volume: local
 Network: host bridge null
Kernel Version: 3.10.0-327.el7.x86_64
Operating System: CentOS Linux 7 (Core)
OSType: linux
Architecture: x86_64
Number of Docker Hooks: 2
CPUs: 2
Total Memory: 989.3 MiB
Name: centos-linux.shared
ID: WYHC:VVGT:BZN6:ONIH:DHIG:HCXK:67FB:AJST:NV3E:DC3R:XPCY:BINE
WARNING: bridge-nf-call-iptables is disabled
WARNING: bridge-nf-call-ip6tables is disabled
Registries: docker.io (secure)
docker info

 

 https://get.docker.com/

#!/bin/sh
set -e
#
# This script is meant for quick & easy install via:
#   \'curl -sSL https://get.docker.com/ | sh\'
# or:
#   \'wget -qO- https://get.docker.com/ | sh\'
#
# For test builds (ie. release candidates):
#   \'curl -fsSL https://test.docker.com/ | sh\'
# or:
#   \'wget -qO- https://test.docker.com/ | sh\'
#
# For experimental builds:
#   \'curl -fsSL https://experimental.docker.com/ | sh\'
# or:
#   \'wget -qO- https://experimental.docker.com/ | sh\'
#
# Docker Maintainers:
#   To update this script on https://get.docker.com,
#   use hack/release.sh during a normal release,
#   or the following one-liner for script hotfixes:
#     aws s3 cp --acl public-read hack/install.sh s3://get.docker.com/index
#

url="https://get.docker.com/"
apt_url="https://apt.dockerproject.org"
yum_url="https://yum.dockerproject.org"
gpg_fingerprint="58118E89F3A912897C070ADBF76221572C52609D"

key_servers="
ha.pool.sks-keyservers.net
pgp.mit.edu
keyserver.ubuntu.com
"

command_exists() {
    command -v "$@" > /dev/null 2>&1
}

echo_docker_as_nonroot() {
    if command_exists docker && [ -e /var/run/docker.sock ]; then
        (
            set -x
            $sh_c \'docker version\'
        ) || true
    fi
    your_user=your-user
    [ "$user" != \'root\' ] && your_user="$user"
    # intentionally mixed spaces and tabs here -- tabs are stripped by "<<-EOF", spaces are kept in the output
    cat <<-EOF

    If you would like to use Docker as a non-root user, you should now consider
    adding your user to the "docker" group with something like:

      sudo usermod -aG docker $your_user

    Remember that you will have to log out and back in for this to take effect!

    EOF
}

# Check if this is a forked Linux distro
check_forked() {

    # Check for lsb_release command existence, it usually exists in forked distros
    if command_exists lsb_release; then
        # Check if the `-u` option is supported
        set +e
        lsb_release -a -u > /dev/null 2>&1
        lsb_release_exit_code=$?
        set -e

        # Check if the command has exited successfully, it means we\'re in a forked distro
        if [ "$lsb_release_exit_code" = "0" ]; then
            # Print info about current distro
            cat <<-EOF
            You\'re using \'$lsb_dist\' version \'$dist_version\'.
            EOF

            # Get the upstream release info
            lsb_dist=$(lsb_release -a -u 2>&1 | tr \'[:upper:]\' \'[:lower:]\' | grep -E \'id\' | cut -d \':\' -f 2 | tr -d \'[[:space:]]\')
            dist_version=$(lsb_release -a -u 2>&1 | tr \'[:upper:]\' \'[:lower:]\' | grep -E \'codename\' | cut -d \':\' -f 2 | tr -d \'[[:space:]]\')

            # Print info about upstream distro
            cat <<-EOF
            Upstream release is \'$lsb_dist\' version \'$dist_version\'.
            EOF
        else
            if [ -r /etc/debian_version ] && [ "$lsb_dist" != "ubuntu" ] && [ "$lsb_dist" != "raspbian" ]; then
                # We\'re Debian and don\'t even know it!
                lsb_dist=debian
                dist_version="$(cat /etc/debian_version | sed \'s/\\/.*//\' | sed \'s/\\..*//\')"
                case "$dist_version" in
                    8|\'Kali Linux 2\')
                        dist_version="jessie"
                    ;;
                    7)
                        dist_version="wheezy"
                    ;;
                esac
            fi
        fi
    fi
}

rpm_import_repository_key() {
    local key=$1; shift
    local tmpdir=$(mktemp -d)
    chmod 600 "$tmpdir"
    for key_server in $key_servers ; do
        gpg --homedir "$tmpdir" --keyserver "$key_server" --recv-keys "$key" && break
    done
    gpg --homedir "$tmpdir" -k "$key" >/dev/null
    gpg --homedir "$tmpdir" --export --armor "$key" > "$tmpdir"/repo.key
    rpm --import "$tmpdir"/repo.key
    rm -rf "$tmpdir"
}

semverParse() {
    major="${1%%.*}"
    minor="${1#$major.}"
    minor="${minor%%.*}"
    patch="${1#$major.$minor.}"
    patch="${patch%%[-.]*}"
}

do_install() {
    case "$(uname -m)" in
        *64)
            ;;
        armv6l|armv7l)
            ;;
        *)
            cat >&2 <<-\'EOF\'
            Error: you are not using a 64bit platform or a Raspberry Pi (armv6l/armv7l).
            Docker currently only supports 64bit platforms or a Raspberry Pi (armv6l/armv7l).
            EOF
            exit 1
            ;;
    esac

    if command_exists docker; then
        version="$(docker -v | awk -F \'[ ,]+\' \'{ print $3 }\')"
        MAJOR_W=1
        MINOR_W=10

        semverParse $version

        shouldWarn=0
        if [ $major -lt $MAJOR_W ]; then
            shouldWarn=1
        fi

        if [ $major -le $MAJOR_W ] && [ $minor -lt $MINOR_W ]; then
            shouldWarn=1
        fi

        cat >&2 <<-\'EOF\'
            Warning: the "docker" command appears to already exist on this system.

            If you already have Docker installed, this script can cause trouble, which is
            why we\'re displaying this warning and provide the opportunity to cancel the
            installation.

            If you installed the current Docker package using this script and are using it
        EOF

        if [ $shouldWarn -eq 1 ]; then
            cat >&2 <<-\'EOF\'
            again to update Docker, we urge you to migrate your image store before upgrading
            to v1.10+.

            You can find instructions for this here:
            https://github.com/docker/docker/wiki/Engine-v1.10.0-content-addressability-migration
            EOF
        else
            cat >&2 <<-\'EOF\'
            again to update Docker, you can safely ignore this message.
            EOF
        fi

        cat >&2 <<-\'EOF\'

            You may press Ctrl+C now to abort this script.
        EOF
        ( set -x; sleep 20 )
    fi

    user="$(id -un 2>/dev/null || true)"

    sh_c=\'sh -c\'
    if [ "$user" != \'root\' ]; then
        if command_exists sudo; then
            sh_c=\'sudo -E sh -c\'
        elif command_exists su; then
            sh_c=\'su -c\'
        else
            cat >&2 <<-\'EOF\'
            Error: this installer needs the ability to run commands as root.
            We are unable to find either "sudo" or "su" available to make this happen.
            EOF
            exit 1
        fi
    fi

    curl=\'\'
    if command_exists curl; then
        curl=\'curl -sSL\'
    elif command_exists wget; then
        curl=\'wget -qO-\'
    elif command_exists busybox && busybox --list-modules | grep -q wget; then
        curl=\'busybox wget -qO-\'
    fi

    # check to see which repo they are trying to install from
    if [ -z "$repo" ]; then
        repo=\'main\'
        if [ "https://test.docker.com/" = "$url" ]; then
            repo=\'testing\'
        elif [ "https://experimental.docker.com/" = "$url" ]; then
            repo=\'experimental\'
        fi
    fi

    # perform some very rudimentary platform detection
    lsb_dist=\'\'
    dist_version=\'\'
    if command_exists lsb_release; then
        lsb_dist="$(lsb_release -si)"
    fi
    if [ -z "$lsb_dist" ] && [ -r /etc/lsb-release ]; then
        lsb_dist="$(. /etc/lsb-release && echo "$DISTRIB_ID")"
    fi
    if [ -z "$lsb_dist" ] && [ -r /etc/debian_version ]; then
        lsb_dist=\'debian\'
    fi
    if [ -z "$lsb_dist" ] && [ -r /etc/fedora-release ]; then
        lsb_dist=\'fedora\'
    fi
    if [ -z "$lsb_dist" ] && [ -r /etc/oracle-release ]; then
        lsb_dist=\'oracleserver\'
    fi
    if [ -z "$lsb_dist" ] && [ -r /etc/centos-release ]; then
        lsb_dist=\'centos\'
    fi
    if [ -z "$lsb_dist" ] && [ -r /etc/redhat-release ]; then
        lsb_dist=\'redhat\'
    fi
    if [ -z "$lsb_dist" ] && [ -r /etc/os-release ]; then
        lsb_dist="$(. /etc/os-release && echo "$ID")"
    fi

    lsb_dist="$(echo "$lsb_dist" | tr \'[:upper:]\' \'[:lower:]\')"

    # Special case redhatenterpriseserver
    if [ "${lsb_dist}" = "redhatenterpriseserver" ]; then
            # Set it to redhat, it will be changed to centos below anyways
            lsb_dist=\'redhat\'
    fi

    case "$lsb_dist" in

        ubuntu)
            if command_exists lsb_release; then
                dist_version="$(lsb_release --codename | cut -f2)"
            fi
            if [ -z "$dist_version" ] && [ -r /etc/lsb-release ]; then
                dist_version="$(. /etc/lsb-release && echo "$DISTRIB_CODENAME")"
            fi
        ;;

        debian|raspbian)
            dist_version="$(cat /etc/debian_version | sed \'s/\\/.*//\' | sed \'s/\\..*//\')"
            case "$dist_version" in
                8)
                    dist_version="jessie"
                ;;
                7)
                    dist_version="wheezy"
                ;;
            esac
        ;;

        oracleserver)
            # need to switch lsb_dist to match yum repo URL
            lsb_dist="oraclelinux"
            dist_version="$(rpm -q --whatprovides redhat-release --queryformat "%{VERSION}\\n" | sed \'s/\\/.*//\' | sed \'s/\\..*//\' | sed \'s/Server*//\')"
        ;;

        fedora|centos|redhat)
            dist_version="$(rpm -q --whatprovides ${lsb_dist}-release --queryformat "%{VERSION}\\n" | sed \'s/\\/.*//\' | sed \'s/\\..*//\' | sed \'s/Server*//\' | sort | tail -1)"
        ;;

        *)
            if command_exists lsb_release; then
                dist_version="$(lsb_release --codename | cut -f2)"
            fi
            if [ -z "$dist_version" ] && [ -r /etc/os-release ]; then
                dist_version="$(. /etc/os-release && echo "$VERSION_ID")"
            fi
        ;;


    esac

    # Check if this is a forked Linux distro
    check_forked

    # Run setup for each distro accordingly
    case "$lsb_dist" in
        amzn)
            (
            set -x
            $sh_c \'sleep 3; yum -y -q install docker\'
            )
            echo_docker_as_nonroot
            exit 0
            ;;

        \'opensuse project\'|opensuse)
            echo \'Going to perform the following operations:\'
            if [ "$repo" != \'main\' ]; then
                echo \'  * add repository obs://Virtualization:containers\'
            fi
            echo \'  * install Docker\'
            $sh_c \'echo "Press CTRL-C to abort"; sleep 3\'

            if [ "$repo" != \'main\' ]; then
                # install experimental packages from OBS://Virtualization:containers
                (
                    set -x
                    zypper -n ar -f obs://Virtualization:containers Virtualization:containers
                    rpm_import_repository_key 55A0B34D49501BB7CA474F5AA193FBB572174FC2
                )
            fi
            (
                set -x
                zypper -n install docker
            )
            echo_docker_as_nonroot
            exit 0
            ;;
        \'suse linux\'|sle[sd])
            echo \'Going to perform the following operations:\'
            if [ "$repo" != \'main\' ]; then
                echo \'  * add repository obs://Virtualization:containers\'
                echo \'  * install experimental Docker using packages NOT supported by SUSE\'
            else
                echo \'  * add the "Containers" module\'
                echo \'  * install Docker using packages supported by SUSE\'
            fi
            $sh_c \'echo "Press CTRL-C to abort"; sleep 3\'

            if [ "$repo" != \'main\' ]; then
                # install experimental packages from OBS://Virtualization:containers
                echo >&2 \'Warning: installing experimental packages from OBS, these packages are NOT supported by SUSE\'
                (
                    set -x
                    zypper -n ar -f obs://Virtualization:containers/SLE_12 Virtualization:containers
                    rpm_import_repository_key 55A0B34D49501BB7CA474F5AA193FBB572174FC2
                )
            else
                # Add the containers module
                # Note well-1: the SLE machine must already be registered against SUSE Customer Center
                # Note well-2: the `-r ""` is required to workaround a known issue of SUSEConnect
                (
                    set -x
                    SUSEConnect -p sle-module-containers/12/x86_64 -r ""
                )
            fi
            (
                set -x
                zypper -n install docker
            )
            echo_docker_as_nonroot
            exit 0
            ;;

        ubuntu|debian|raspbian)
            export DEBIAN_FRONTEND=noninteractive

            did_apt_get_update=
            apt_get_update() {
                if [ -z "$did_apt_get_update" ]; then
                    ( set -x; $sh_c \'sleep 3; apt-get update\' )
                    did_apt_get_update=1
                fi
            }

            if [ "$lsb_dist" = "raspbian" ]; then
                # Create Raspbian specific systemd drop-in file, use overlay by default
                ( set -x; $sh_c "mkdir -p /etc/systemd/system/docker.service.d" )
                ( set -x; $sh_c "echo \'[Service]\\nExecStart=\\nExecStart=/usr/bin/dockerd --storage-driver overlay -H fd://\' > /etc/systemd/system/docker.service.d/overlay.conf" )
            

以上是关于docker的主要内容,如果未能解决你的问题,请参考以下文章

markdown docker-compose片段

sh Docker片段

《Docker 源码分析》全球首发啦!

docker 部署 coredns(内部域名解析)

docker 部署 coredns(内部域名解析)

将 Docker 容器限制为单个 cpu 核心